unit Main;

interface

uses
  Windows, SysUtils, Graphics, Controls, Forms, StdCtrls, ExtCtrls, Classes,
  Dialogs;

type
  TForm1 = class(TForm)
    Edit1        : TEdit;
    Label1       : TLabel;
    Button1      : TButton;
    Image1       : TImage;
    Image2       : TImage;
    Image3       : TImage;
    Image4       : TImage;
    Image5       : TImage;
    Image6       : TImage;
    TargetImage  : TImage;
    RadioButton1 : TRadioButton;
    RadioButton2 : TRadioButton;
    RadioButton3: TRadioButton;
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    Procedure LoadNextPicture(PNum: Integer);
  private
    { Private-Deklarationen }
    Procedure WriteImages;
  public
    { Public-Deklarationen }
  end;

var
 Form1: TForm1;

implementation

{$R *.dfm}

uses
 AviWriter_Single_Compressed;

Procedure TForm1.LoadNextPicture(PNum: Integer);
begin
 TargetImage.Picture.Bitmap.Assign(
            TImage(Findcomponent('Image' + IntToStr(PNum + 1))).Picture.Graphic);
end;

Procedure TForm1.WriteImages;
var
 From, NumPics,
 fn, i         : Integer;
 Error         : Boolean;
begin
 Error:= False;
 If RadioButton1.Checked then
 begin
  From:= 0;
  NumPics:= 3;
 end
 else If RadioButton2.Checked then
 begin
  From:= 3;
  NumPics:= 3;
 end
 else
 begin
  From:= 0;
  NumPics:= 6;
 end;
 LoadNextPicture(From);
 //AVIwriter gets a pointer to main form image
 AVIBitmap.Clear;
 AVIBitmap.Add(TargetImage.Picture.Bitmap);
 //Initialize
 If AVI_Initiate(Self.Handle, Edit1.Text) then
 begin
  fn:= 0;
  i:= From;
  While i < From + NumPics do
  begin
   LoadNextPicture(i); //Display next image in Target Image Frame
   //Add it to the AVI File
   If not AVIAddFrame(fn) then
   begin //unable to add the bitmap to the video
    Beep;
    Error:= True;
    Break;
   end;
   Inc(i);
   Inc(fn);
  end;
  AVI_Close;
 end
 else
  Error:= True;

 If Error then
  ShowMessage('File Save terminated with error')
 else
  ShowMessage('File successfully saved to disk');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin //create AVI File
 WriteImages;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 RadioButton1.Checked:= True;
 Self.Caption:= 'AVI Compressed File Writer by Matthias Walter';
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
 LoadNextPicture(0);
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
 LoadNextPicture(3);
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
 LoadNextPicture(0);
end;

end.
